//+------------------------------------------------------------------+
//|                                             .mq4 |
//|                                               Copyright  Egori4 |
//|                                                  goka_ee@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  Egori4"
#property link      "goka_ee@mail.ru"

extern double StopLoss   =30;                  // SL   
extern double TakeProfit =100;                 //    
extern double Lots       =0;                    //   . 
bool Work=true;                                 //   .
string Symb;                                    //  . 
extern string timeFrame = "H1";                 // 
double timeP;
int pop_B=0;
int pop_S=0;
static datetime  New_Day_DateTime  = 0 ;  //  
extern double PP=10;                            //     

void init()
{
  if ( GlobalVariableCheck("gNew_Day_DateTime") == false )
  {
      GlobalVariableSet("gNew_Day_DateTime",iTime(Symbol(),PERIOD_D1,0));
  }  
  else
  {
      New_Day_DateTime = GlobalVariableGet("gNew_Day_DateTime");
  }
 }
//----------------------------------------------------  --
void start()
//     
  {
   int
   count1,                                      //   1
   count2,                                      //   2
   Tip=-1,                                      //  .  (B=0,S=1)
   Ticket,
   Ticket_S,                                    //   Sell
   Ticket_B;                                    //   Buy
   double
   MAX_Price,                                   //      
   MIN_Price,                                   //      
   WL,                                          
   Balanse1,
   Lot,                                         // .   .
   Lts,                                         // .   .
   Min_Lot,                                     //   
   Step,                                        //    
   Free,                                        //   
   One_Lot,                                     //   
   Price,                                       //   
   SL,
   TP,
   SL_B,                                        // SL   Buy
   SL_S,                                        // SL   Sell
   TP_B,                                        // TP   Buy
   TP_S;                                        // TP   Sell

   bool
   Ans  =false,                                 //    
   Cls_B=false,                                 //     Buy
   Cls_S=false,                                 //     Sell
   Opn_B=false,                                 //     Buy
   Opn_S=false;                                 //     Sell
   

    Symb=Symbol();
    count1=0;
      for(int i=0;i<OrdersTotal();i++)
         {
          if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
            {
             if(OrderSymbol()==Symbol())
              {
               if(OrderMagicNumber()==1)
                 {
                  count1++;
         Ticket=OrderTicket();                  //  . .
         Tip   =OrderType();                    //   .
         Price =OrderOpenPrice();               //  . .
         SL    =OrderStopLoss();                // SL  .
         TP    =OrderTakeProfit();              // TP  .
         Lot   =OrderLots();                    //  
                  }
               }
             }
           }
           
              count2=0;
      for(i=0;i<OrdersTotal();i++)
         {
          if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
            {
             if(OrderSymbol()==Symbol())
               {
                if(OrderMagicNumber()==2)
                  {
                   count2++;
         Ticket=OrderTicket();                  //  . .
         Tip   =OrderType();                    //   .
         Price =OrderOpenPrice();               //  . .
         SL    =OrderStopLoss();                // SL  .
         TP    =OrderTakeProfit();              // TP  .
         Lot   =OrderLots();                    //  
                   }
                }
              }
            }


//----------------------------------------    --

   //   .
   if (timeFrame == "M1")
      timeP = PERIOD_M1;
   if (timeFrame == "M5")
      timeP = PERIOD_M5;
   if (timeFrame == "M15")
      timeP = PERIOD_M15;
   if (timeFrame == "M30")
      timeP = PERIOD_M30;
   if (timeFrame == "H1")
      timeP = PERIOD_H1;
   if (timeFrame == "H4")
      timeP = PERIOD_H4;
   if (timeFrame == "D1")
      timeP = PERIOD_D1;


  if (iTime(Symbol(),PERIOD_D1,0) != New_Day_DateTime)
   {
         New_Day_DateTime = iTime(Symbol(),PERIOD_D1,0);           //   
         GlobalVariableSet("gNew_Day_DateTime",New_Day_DateTime);  //       -    
   

  MAX_Price=iHigh(NULL,PERIOD_D1,1);
  Alert("     ",MAX_Price);
  
  MIN_Price=iLow(NULL,PERIOD_D1,1);
  Alert("     ",MIN_Price);
  
  
      int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);// . 
    
      if (NormalizeDouble(MAX_Price,Digits)<        //   .
         NormalizeDouble(Ask+Min_Dist*Point,Digits))
        {                                       //   BuyStop!
         Opn_B=true;
        }
      if (Ask > MAX_Price)
        {                                      
         Opn_B=false;
        }
     
      if (NormalizeDouble(MIN_Price,Digits)<        //   .
         NormalizeDouble(Bid-Min_Dist*Point,Digits))
        {                                       
         Opn_S=true;
        }
       if (Bid < MIN_Price )
        {                                      
         Opn_S=false;
        }
     pop_B=0;
     pop_S=0;
     }   

//-----------------------------------------------   -- 
   RefreshRates();                              //  
   Min_Lot=MarketInfo(Symb,MODE_MINLOT);        // . .  
   Free   =AccountFreeMargin();                 //  
   One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);//  1 
   Step   =MarketInfo(Symb,MODE_LOTSTEP);       //   
   
          
   if (Lots > 0)                                //   , 
      Lts =Lots;                                //     
                 
   if (Lts < Min_Lot)                           //   
      {
       Lts=Min_Lot;
       }               
   if (Lts*One_Lot > Free)                      //   .
     {
      Alert("     ", Lts," ");
      return;                                   //   start()
      }
//-----------------------------------------------   -- 

   while(true)                                  //   .
     {
      if (count1<1 && Opn_B==false && Ticket_B<1 && pop_B==0)              //  .  +
        {                                       //  . Buy
         RefreshRates();                        //  
         SL_B=MAX_Price - StopLoss*Point;          //   SL
         TP_B=MAX_Price + ((Ask-Bid)/Point) + TakeProfit*Point;          //   
         Ticket_B=OrderSend(Symbol(), OP_BUYSTOP, Lts, MAX_Price-((Ask-Bid)/Point), 0, SL_B, TP_B,"1",1,0,CLR_NONE);
           {
            Alert("  B   .  ..");
             if (Ticket_B>0)                             //  :)
              {
              Alert ("  BuyStop ",Ticket_B);
              pop_B=1;
              }
           }
         if (Fun_Error(GetLastError())==1)      //  
         continue;                              //  
         return;                                //   start()
        }
     
     
       if (count1<1 && Opn_B==true && pop_B==0)              //  .  +
        {                                       //  . Buy
         RefreshRates();                        //  
         SL=Bid - New_Stop(StopLoss)*Point;     //  SL .
         TP=Bid + New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Buy.  ..");
         Ticket=OrderSend(Symbol(),OP_BUY,Lts,Ask,0,SL,TP,"1",1,0,CLR_NONE);// Buy
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Buy ",Ticket);
            pop_B=1;
            return;                             //   start()
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }

     
        if (count2<1 && Opn_S==false && Ticket_S<1 && pop_S==0)              //  .  +
        {                                          //  . Sell
         RefreshRates();                           //  
         SL_S=MIN_Price + StopLoss*Point;          //   SL
         TP_S=MIN_Price + ((Ask-Bid)/Point) - TakeProfit*Point;          //   
          Ticket_S=OrderSend(Symb, OP_SELLSTOP, Lts, MIN_Price, 0, SL_S, TP_S,"2",2,0,CLR_NONE);
            {
             Alert("  S   .  ..");
             if (Ticket_S>0)                             //  :)
               {
                Alert ("  SellStop ",Ticket_S);
                pop_S=1;
               }
             }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      if (count2<1 && Opn_S==true && pop_S==0)              //  .  +
        {                                       //  . Sell
         RefreshRates();                        //  
         SL=Ask + New_Stop(StopLoss)*Point;     //  SL .
         TP=Ask - New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Sell.  ..");
         Ticket=OrderSend(Symbol(),OP_SELL,Lts,Bid,0,SL,TP,"2",2,0,CLR_NONE);      // Sel
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Sell ",Ticket);
            pop_S=1;
            return;                             //   start()
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }

         break;                                    //   while
       }
 
//------------------------------------------------------------ --
   return;                                      //   start()
  }
//-------------------------------------------------  --
int Fun_Error(int Error)                        // -  
  {
   switch(Error)
     {                                          //              
      case  4: Alert("  .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 135:Alert(" .   ..");
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..");
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 146:Alert("  .  ..");
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .");
         return(0);                             //   
      case  5: Alert("  .");
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .");
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .");
         return(0);                             //   
      case 134:Alert("    .");
         return(0);                             //   
      default: Alert("  ",Error); //     
         return(0);                             //   
     }
  }
//-------------------------------------------------------------- 11 --
int New_Stop(int Parametr)                      //  -.
  {
   int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);// . 
   if (Parametr < Min_Dist)                     //   .
     {
      Parametr=Min_Dist;                        //  .
      Alert("  -.");
     }
   return(Parametr);                            //  
  }
//------------------------------------------------------------ --